;======================================================;
; Keymap.                                          USA ;
;======================================================;
format binary as 'dex'				       ;
use32						       ;
	ORG	0x1A00000			       ; where our program is loaded to
	jmp	start				       ; jump to the start of program.
	db	'DEX6'				       ; We check for this, to make shore it a valid DexOS file.
;===================================================== ;
; Start of program.                                    ;
;===================================================== ;
start:						       ;
	mov   ax,18h				       ;
	mov   ds,ax				       ;
	mov   es,ax				       ;
 ;----------------------------------------------------;;
 ; Get calltable address.                             ;;
 ;----------------------------------------------------;;
	mov   edi,Functions			       ; this is the interrupt
	mov   al,0				       ; we use to load the DexFunction.inc
	mov   ah,0x0a				       ; with the address to dex4u functions.
	int   50h				       ;
						       ;
	call  [KeyBoardLanguage]		       ; Get the pointer to the KeyMap
	cmp   eax,'KEYB'			       ; Check its not a old ver of DexOS, without this function
	jne   ExitER				       ; Print error message if so
	mov   esi,normal_keymap 		       ; Point esi, to new map, (edi is pointing to old map)
	mov   ecx,1024				       ; Its 1024 bytes in size
	rep   movsb				       ; Move the new map over the old.
ExitOK: 					       ;
	mov   esi,KeyBoardOK			       ;
	call  [PrintString_0]			       ; Print sucsess maessage
	ret					       ; Exit.
						       ;
ExitER: 					       ;
	mov   esi,KeyBoardER			       ;
	call  [PrintString_0]			       ; Print error maessage
	ret					       ; Exit.
						       ;
 ;----------------------------------------------------;;
 ; calltable include goes here.                       ;;
 ;----------------------------------------------------;;
KeyBoardOK: db 'USA language keyboard, sucsessfully installed',10,13,0
KeyBoardER: db 'Error!, you need a ver 6 or later of kernel32',10,13,0

;====================================================;
; Normal Keymap.                                 USA ;
;====================================================;
;                                                    ;
; NOTE: This is the layout of keyboard and you most  ;
; have them in this order and 16*16 each of them.    ;
; 1024 in all.                                       ;
;                                                    ;
;====================================================;
normal_keymap:
db	0,   27,  '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '-', '=', 8,   9
db	'q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '[', ']', 13,  0,   'a', 's'
db	'd', 'f', 'g', 'h', 'j', 'k', 'l', ';', 39,  '`', 0,   '\',  'z', 'x', 'c', 'v'
db	'b', 'n', 'm', ',', '.', '/', 0,   '*', 0,   ' ', 0,   3,   3,	 3,   3,   3
db	3,   3,   3,   3,   3,	 0,   0,   0,	0,   0,   '-', 0,   0,	 0,   '+', 0
db	0,   0,   0,   255, 0,	 0,   92,  3,	3,   0,   0,   0,   0,	 0,   0,   0
db	13,  0,   '/', 0,   0,	 0,   0,   0,	0,   0,   0,   0,   0,	 0,   0,   127
db	0,   0,   0,   0,   0,	 0,   0,   0,	0,   0,   '/', 0,   0,	 0,   0,   0
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255

;====================================================;
; Shift Keymap.                                  USA ;
;====================================================; 
shift_keymap:
db	0,   27,  '!', '@', '#', '$', '%', '^', '&', '*', '(', ')', '_', '+', 126, 126
db	'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', '{', '}', 13, 0,   'A', 'S'
db	'D', 'F', 'G', 'H', 'J', 'K', 'L', ':', '"',  '~', 0, '|', 'Z', 'X', 'C', 'V'
db	'B', 'N', 'M', '<', '>', '?', 0,   '*', 0,  ' ',   0,	1,   1,   1,   1,   1
db	1,   1,   1,   1,   1,	 0,   0,   0,	0,   0,   '-', 0,   0,	 0,   '+', 0
db	0,   0,   1,   127, 0,	 0, '|',   1,	1,   0,   0,   0,   0,	 0,   0,   0
db	13,  0,  '/',  0,   0,	 0,   0,   0,	0,   0,   0,   0,   0,	 0,   0,   255
db	0,   0,   0,   0,   0,	 0,   0,   0,	0,   0,   '/', 0,   0,	 0,   0,   0
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255

;====================================================;
; Alt Keymap.                                   USA  ;
;====================================================; 
alt_keymap:
db	0,   0,   2,   2,   2,	 2,   2,   2,	2,   2,   2,   2,   0,	 0,   127, 127
db	17,  23,  5,   18,  20,  25,  21,  9,	15,  16,  2,   2,   10,  0,   1,   19
db	4,   6,   7,   8,   10,  11,  12,  0,	0,   0,   0,   0,   26,  24,  3,   22
db	2,   14,  13,  0,   0,	 0,   0,   0,	0,   0,   0,   2,   2,	 2,   2,   2
db	2,   2,   2,   2,   2,	 0,   0,   0,	0,   0,   0,   0,   0,	 0,   0,   0
db	0,   0,   2,   0,   0,	 0,   0,   2,	2,   0,   0,   0,   0,	 0,   0,   0
db	0,   0,   0,   0,   0,	 0,   0,   0,	0,   0,   0,   0,   0,	 0,   0,   0
db	0,   0,   0,   0,   0,	 0,   0,   0,	0,   0,   0,   0,   0,	 0,   0,   0
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255

;====================================================;
; Caplock Keymap.                               USA  ;
;====================================================; 
caplock_keymap:
db	0,   27,  '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '-', '=', 8,   9
db	'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', '[', ']', 13,  0,   'A', 'S'
db	'D', 'F', 'G', 'H', 'J', 'K', 'L', ';', 39,  '`', 0,  '#',  'Z', 'X', 'C', 'V'
db	'B', 'N', 'M', ',', '.', '/', 0,   '*', 0,   ' ', 0,   3,   3,	 3,   3,   3
db	3,   3,   3,   3,   3,	 0,   0,   0,	0,   0,   '-', 0,   0,	 0,   '+', 0
db	0,   0,   0,   127, 0,	 0,   92,  3,	3,   0,   0,   0,   0,	 0,   0,   0
db	13,  0,   '/', 0,   0,	 0,   0,   0,	0,   0,   0,   0,   0,	 0,   0,   127
db	0,   0,   0,   0,   0,	 0,   0,   0,	0,   0,   '/', 0,   0,	 0,   0,   0
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255
db	255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255 ,255



include 'Dex.inc'					; Dex inc file
